var APP = APP || {};

/**
 *  0: STANDALONE/No tracking 
 *  1: SCORM1.2 -- current
 *  2: SCORM2004 v4 
 */

APP.complianceType = 1;
APP.erroMsgObj={
    apiFailPopText: "API not found.\n\nPlease contact your Technical Support for assistance.",
    lmsWinClosedPopText: "The SCORM API is no longer available.\n\nThe Learning Application window may not be available and your progress will no longer be tracked.",
    networkFailPopText: "Lms connection lost.\n\nPlease contact your Technical Support for assistance.",
    
}
APP.queCount = 0;
APP.queData01={
    questionText: 'QUESTION TEXT - Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut bibendum convallis tempor. ',
	qId: 'que-'+Math.floor(Math.random() * 100),
    dataTobeSend: true,
    type: 'mcq',
    options: ['option text 01','option text 02', 'option text 03', 'option text 04'],
    dataUserArray: [1,0,0,0],
    dataAnswerArray: [0,0,1,0],
    dataStatus: 'incorrect',
    dataEarnPoint: 0,
    dataIsUserOptionSelected: true,
    dataStartTime: ''

}
APP.queData02={
    questionText: 'QUESTION TEXT - Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut bibendum convallis tempor. ',
	qId: 'que-'+Math.floor(Math.random() * 100),
    dataTobeSend: true,
    type: 'mrq',
    options: ['option text 01','option text 02', 'option text 03', 'option text 04'],
    dataUserArray: [1,1,0,0],
    dataAnswerArray: [1,1,0,0],
    dataStatus: 'correct',
    dataEarnPoint: 1,
    dataIsUserOptionSelected: true,
    dataStartTime: ''

}

APP.beforeUnloadFired = false;
APP.courseClosed=false;
APP.winWillClose=false;
APP.winOpener = top.opener;

APP.courseSusData="";
APP.courseBookmark="";
APP.courseStatus="";
APP.courseScore="";
APP.currentTime;

var winWd = window.screen.availWidth;
var winHt = window.screen.availHeight;
window.moveTo(0, 0);
window.resizeTo(winWd, winHt);

$(document).ready(function () {
    initilize();
    

});

function initilize(){
    APP.dataComObj = new DataCompliance();
    APP.currentTime = new Date();
    APP.dataComObj.start();  
}

function startApp(){
    applyEvent();
    var _v = '';
    if(APP.complianceType == 1){
        _v = "SCORM 1.2"
    }else if(APP.complianceType == 2){
        _v = "SCORM 2004"
    }else{
        _v = "Web version / No tracking" 
    }

    $('.dy-version').html(_v);
    $('.dy-learner-id').html(APP.dataComObj.getStudentId());
    $('.dy-learner-name').html(APP.dataComObj.getStudentName());
    
    APP.courseSusData = APP.dataComObj.getSuspendData();
    APP.courseBookmark = APP.dataComObj.getBookMark();
    APP.courseStatus = APP.dataComObj.getLessonStatus();
    APP.courseScore = APP.dataComObj.getScoreRaw();
    
    if(APP.courseSusData != null && APP.courseSusData != "null" && APP.courseSusData != '' ){           
        $('.row-suspend-data').find('.input-box').val( APP.courseSusData);
    }

    if(APP.courseBookmark != null && APP.courseBookmark != "null" && APP.courseBookmark != '' ){
        $('.row-bookmark').find('.input-box').val( APP.courseBookmark);
    }

    if(APP.courseStatus != null && APP.courseStatus != "null" && APP.courseStatus != '' ){
        $('.row-status').find('select').val(APP.courseStatus);
    }

    if(APP.courseScore != null && APP.courseScore != "null" && APP.courseScore != '' ){
        $('.row-score').find('.input-box').val(APP.courseScore);
    }
}


function applyEvent(){
    $('.btn-get').on('click', function(){
        APP.dataComObj.getLastLMSData();
        APP.courseSusData = APP.dataComObj.getSuspendData();
        APP.courseBookmark = APP.dataComObj.getBookMark();
        APP.courseStatus = APP.dataComObj.getLessonStatus();
        APP.courseScore = APP.dataComObj.getScoreRaw();

        if(APP.courseSusData != null && APP.courseSusData != "null" && APP.courseSusData != '' ){           
            $('.row-suspend-data').find('.input-box').val( APP.courseSusData);
        }

        if(APP.courseBookmark != null && APP.courseBookmark != "null" && APP.courseBookmark != '' ){
            $('.row-bookmark').find('.input-box').val( APP.courseBookmark);
        }

        if(APP.courseStatus != null && APP.courseStatus != "null" && APP.courseStatus != '' ){
            $('.row-status').find('select').val(APP.courseStatus);
        }

        if(APP.courseScore != null && APP.courseScore != "null" && APP.courseScore != '' ){
            $('.row-score').find('.input-box').val(APP.courseScore);
        }

    });
    $('.btn-set').on('click', function(){

        var _tsd = $('.row-suspend-data').find('.input-box').val().trim();
        if(_tsd === '' || _tsd == null){
            alert('Please add some inputs in Suspend Data');
            return false;
        }else{
            APP.courseSusData= _tsd;
        }

        var _tbm = $('.row-bookmark').find('.input-box').val().trim();
        if(_tbm === '' || _tbm == null){
            alert('Please add some inputs in Bookmark');
            return false;
        }else{
            APP.courseBookmark= _tbm;
        }

        var _tst = $('.row-status').find('select').val();
        if(_tst === '' || _tst == null){
            alert('Please select Status');
            return false;
        }else{
            APP.courseStatus= _tst;
        }

        var _tsc = $('.row-score').find('.input-box').val().trim();
        if(_tsc === '' || _tsc == null ){
            alert('Please add Score between 0 and 100');
            return false;
        }else{
            APP.courseScore= _tsc;
        }
        APP.dataComObj.updateUserData();        
        updateResultTxt('Data sent to LMS');
    });

    $('.btn-que').on('click', function(){
        if(APP.queCount % 2 == 0){
            APP.queData01.dataStartTime = new Date();
            APP.dataComObj.sendInlineInteractionData(APP.queData01);
        }else{
            APP.queData02.dataStartTime = new Date();
            APP.dataComObj.sendInlineInteractionData(APP.queData02);
        }  
        APP.queCount++;
        updateResultTxt('Interaction Data sent to LMS');
    });

    $('.btn-complete').on('click', function(){
        APP.courseStatus= 'completed';
        $('.row-status').find('select').val(APP.courseStatus);
        
        updateResultTxt('Completion set on LMS');
        APP.dataComObj.updateUserData();
    });


    $('.btn-exit').on('click', function(){
        var _tsd = $('.row-suspend-data').find('.input-box').val().trim();
        if(_tsd === '' || _tsd == null){           
        }else{
            APP.courseSusData= _tsd;
        }

        var _tbm = $('.row-bookmark').find('.input-box').val().trim();
        if(_tbm === '' || _tbm == null){
            
        }else{
            APP.courseBookmark= _tbm;
        }

        var _tst = $('.row-status').find('select').val();
        if(_tst === '' || _tst == null){
            
        }else{
            APP.courseStatus= _tst;
        }

        var _tsc = $('.row-score').find('.input-box').val().trim();
        if(_tsc === '' || _tsc == null ){
            
        }else{
            APP.courseScore= _tsc;
        }
        APP.dataComObj.updateUserData(); 

        APP.winWillClose=true;				
		window.top.close();
    });
}

function createData(){

}
function updateResultTxt(_val){
    $('.row-result').html(_val);
    setTimeout(function(){
        $('.row-result').html('');
    }, 5000);
}

function winUnloaded(e){
    if((APP.complianceType!= null && APP.complianceType.toString() != "0") && APP.dataComObj != null){
        APP.dataComObj.closeCourse();
    }	
}